<!--
Copyright © Institut für Qualitätsentwicklung an Schulen Schleswig-Holstein (IQSH)

SPDX-License-Identifier: AGPL-3.0-or-later
-->

<script setup lang="ts">
import { ref } from 'vue';
import { storeToRefs } from 'pinia';
import Modal from '@/components/general/Modal.vue';
import { useFreeformStore } from '@/stores/freeform';
import Input from '@/components/general/form/Input.vue';

const store = useFreeformStore();
const { lineId, lineArray: getLineArray, getStyle } = storeToRefs(store);
const lineIndex = getLineArray.value!.findIndex((x:any)=> x.id === lineId.value);
const lineText = ref(getLineArray.value![lineIndex].text?getLineArray.value![lineIndex].text:'.');

const emits = defineEmits<{
    (e: 'close'):void
}>();

const close = ()=>{
    lineId.value = '';
    emits('close');
};

const submit = ()=>{
    store.editLine({lineIndex: lineIndex, text: lineText.value?lineText.value:'.'});
    close();
};

const isDeleteLineModalOpen = ref(false);
const showDeleteLineModal = (value: boolean) => {
    isDeleteLineModalOpen.value = value;
    if (!value) {
        emits('close');
    }
};

const submitDeleteLine = () => {
    store.deleteLine({ lineIndex: lineIndex });
    showDeleteLineModal(false);
};

</script>
<template>
<Modal :header="$t('create.line.editLine')" @cancel="close" :labelCancel="$t('general.buttons.cancel')" @submit="submit" :labelSubmit="$t('adjustPanel.submit')" :font="getStyle?.font?getStyle.font:''" iconLeft="true" :tooltipLeft="$t('contentPage.deleteLabel')" iconLeftColor="text-red-700" @left="showDeleteLineModal(true)">
    <template #iconLeft><i class="ri-delete-bin-line ri-xl"></i></template>
    <Input type="text" v-model="lineText" :placeholder="$t('contentPage.lineText')" :label="$t('contentPage.lineText')" />
</Modal>
<Modal v-if="isDeleteLineModalOpen" :text="$t('contentPage.deleteLine')" @cancel="showDeleteLineModal(false)"
        :labelCancel="$t('general.buttons.cancel')" @submit="submitDeleteLine" :labelSubmit="$t('general.buttons.ok')"
        :font="getStyle?.font ? getStyle.font : ''"/>
</template>